unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    SetLedB: TButton;
    SetLedsRangeB: TButton;
    SetLedsB: TButton;
    GetLedB: TButton;
    GetLedsB: TButton;
    ClearLedsB: TButton;
    SetLed_led: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SetLed_value: TEdit;
    Label3: TLabel;
    SetLedsRange_led: TEdit;
    Label4: TLabel;
    SetLedsRange_count: TEdit;
    Label5: TLabel;
    SetLedsRange_value: TEdit;
    Label6: TLabel;
    GetLed_led: TEdit;
    Label7: TLabel;
    GetLed_value: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    SetLeds_count: TEdit;
    GetLeds_count: TEdit;
    procedure SetLedBClick(Sender: TObject);
    procedure ClearLedsBClick(Sender: TObject);
    procedure SetLedsRangeBClick(Sender: TObject);
    procedure SetLedsBClick(Sender: TObject);
    procedure GetLedBClick(Sender: TObject);
    procedure GetLedsBClick(Sender: TObject);
    procedure ShowError(res: integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  ps2_leds;

{$R *.dfm}

procedure TForm1.SetLedBClick(Sender: TObject);
Var
	res : Integer;
begin
  res:=SetLed(StrToInt(SetLed_led.Text),StrToInt(SetLed_value.Text));
  If res <> ERROR_NOERROR then ShowError(res);
end;

procedure TForm1.ClearLedsBClick(Sender: TObject);
Var
	res : Integer;
begin
  res:=ClearLeds;
  If res <> ERROR_NOERROR then ShowError(res);
end;

procedure TForm1.SetLedsRangeBClick(Sender: TObject);
Var
	res : Integer;
begin
  res:=SetLedsRange(StrToInt(SetLedsRange_led.Text),StrToInt(SetLedsRange_count.Text),StrToInt(SetLedsRange_value.Text));
  If res <> ERROR_NOERROR then ShowError(res);
end;

procedure TForm1.SetLedsBClick(Sender: TObject);
var buf :array [1..129] of byte;
  i, res: integer;
begin
FillChar(buf, 129,0);

  for i:=1 to 64 do
   buf[i]:=random(15)+1;

  res:=SetLeds(StrToInt(SetLeds_count.Text), @buf);
  If res <> ERROR_NOERROR then ShowError(res);
end;

procedure TForm1.GetLedBClick(Sender: TObject);
Var k: byte;
    res : Integer;
begin
  res:=GetLed(StrToInt(GetLed_led.Text),k);
  If res <> ERROR_NOERROR
    then ShowError(res)
    else GetLed_value.Text:=IntToStr(k);
end;

procedure TForm1.GetLedsBClick(Sender: TObject);
var buf :array [1..129] of byte;
  i, res: integer;
begin
  res:=GetLeds(StrToInt(GetLeds_count.Text), @buf);
  If res <> ERROR_NOERROR then begin
    ShowError(res);
    Exit;
  end;  

  for i:=1 to StrToInt(GetLeds_count.Text) do
   begin
     buf[i]:=buf[i]+1;
     if buf[i]>15
       then buf[i]:=1;
   end;
  SetLeds(StrToInt(GetLeds_count.Text), @buf);
  If res <> ERROR_NOERROR then ShowError(res);
end;

//      
procedure TForm1.ShowError(res: integer);
begin
  Case res of
		//ERROR_NO_ERROR				    : ShowMessage('  ');
		ERROR_OSNOTSUPPORTED				: ShowMessage('     PS/2 ');
    ERROR_NODRIVER				      : ShowMessage('    PS/2 ');
    ERROR_RECEIVETIMEOUT				: ShowMessage('   ');
    Else ShowMessage('  '+IntToStr(res));
  End;
end;

end.
